> For clean Markdown of any page, append `.md` to the page URL.
> For a complete documentation index, see https://docs.sarvam.ai/llms.txt.
> For full documentation content in one file, see https://docs.sarvam.ai/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.sarvam.ai/_mcp/server.

# Translation

POST https://api.sarvam.ai/translate
Content-Type: application/json

**Translation** converts text from one language to another while preserving its meaning.
For Example: **'मैं ऑफिस जा रहा हूँ'** translates to **'I am going to the office'** in English, where the script and language change, but the original meaning remains the same.

Available languages:
- **`bn-IN`**: Bengali
- **`en-IN`**: English
- **`gu-IN`**: Gujarati
- **`hi-IN`**: Hindi
- **`kn-IN`**: Kannada
- **`ml-IN`**: Malayalam
- **`mr-IN`**: Marathi
- **`od-IN`**: Odia
- **`pa-IN`**: Punjabi
- **`ta-IN`**: Tamil
- **`te-IN`**: Telugu

### Newly added languages:
- **`as-IN`**: Assamese
- **`brx-IN`**: Bodo
- **`doi-IN`**: Dogri
- **`kok-IN`**: Konkani
- **`ks-IN`**: Kashmiri
- **`mai-IN`**: Maithili
- **`mni-IN`**: Manipuri (Meiteilon)
- **`ne-IN`**: Nepali
- **`sa-IN`**: Sanskrit
- **`sat-IN`**: Santali
- **`sd-IN`**: Sindhi
- **`ur-IN`**: Urdu

For hands-on practice, you can explore the notebook tutorial on [Translate API Tutorial](https://github.com/sarvamai/sarvam-ai-cookbook/blob/main/notebooks/translate/Translate_API_Tutorial.ipynb).

Reference: https://docs.sarvam.ai/api-reference/text/translate-text

## Authentication

- `api-subscription-key` header (required)

## Request

### Body (application/json)

- `input` (string, required) — The text you want to translate is the input text that will be processed by the translation model. The maximum is 1000 characters for Mayura:v1 and 2000 characters for Sarvam-Translate:v1.
- `source_language_code` (enum, required) — Source language code for translation input. **mayura:v1 Languages:** Bengali, English, Gujarati, Hindi, Kannada, Malayalam, Marathi, Odia, Punjabi, Tamil, Telugu **sarvam-translate:v1 Languages:** All mayura:v1 languages and Assamese, Bodo, Dogri, Konkani, Kashmiri, Maithili, Manipuri, Nepali, Sanskrit, Santali, Sindhi, Urdu **Note:** mayura:v1 supports automatic language detection using 'auto' as the source language code.
  - Allowed values: `auto`, `bn-IN`, `en-IN`, `gu-IN`, `hi-IN`, `kn-IN`, `ml-IN`, `mr-IN`, `od-IN`, `pa-IN`, `ta-IN`, `te-IN`, `as-IN`, `brx-IN`, `doi-IN`, `kok-IN`, `ks-IN`, `mai-IN`, `mni-IN`, `ne-IN`, `sa-IN`, `sat-IN`, `sd-IN`, `ur-IN`
- `target_language_code` (enum, required) — The language code of the translated text. This specifies the target language for translation. **mayura:v1 Languages:** Bengali, English, Gujarati, Hindi, Kannada, Malayalam, Marathi, Odia, Punjabi, Tamil, Telugu **sarvam-translate:v1 Languages:** All mayura:v1 and Assamese, Bodo, Dogri, Konkani, Kashmiri, Maithili, Manipuri, Nepali, Sanskrit, Santali, Sindhi, Urdu
  - Allowed values: `bn-IN`, `en-IN`, `gu-IN`, `hi-IN`, `kn-IN`, `ml-IN`, `mr-IN`, `od-IN`, `pa-IN`, `ta-IN`, `te-IN`, `as-IN`, `brx-IN`, `doi-IN`, `kok-IN`, `ks-IN`, `mai-IN`, `mni-IN`, `ne-IN`, `sa-IN`, `sat-IN`, `sd-IN`, `ur-IN`
- `speaker_gender` (enum, optional) — Please specify the gender of the speaker for better translations.
  - Allowed values: `Male`, `Female`
- `mode` (enum, optional) — Specifies the tone or style of the translation. **Model Support:** - **mayura:v1**: Supports formal, classic-colloquial, modern-colloquial, and code-mixed modes - **sarvam-translate:v1**: Only formal mode is supported **Default:** formal
  - Allowed values: `formal`, `modern-colloquial`, `classic-colloquial`, `code-mixed`
- `model` (enum, optional) — Specifies the translation model to use. - mayura:v1: Supports 12 languages with all modes, output scripts, and automatic language detection. - sarvam-translate:v1: Supports all 22 scheduled languages of India, formal mode only.
  - Allowed values: `mayura:v1`, `sarvam-translate:v1`
- `output_script` (enum, optional, nullable) — **output_script**: This is an optional parameter which controls the transliteration style applied to the output text. **Transliteration**: Converting text from one script to another while preserving pronunciation. For mayura:v1 - We support transliteration with four options: - **`null`**(default): No transliteration applied. - **`roman`**: Transliteration in Romanized script. - **`fully-native`**: Transliteration in the native script with formal style. - **`spoken-form-in-native`**: Transliteration in the native script with spoken style. For sarvam-translate:v1 - Transliteration is not supported. ### Example: English: Your EMI of Rs. 3000 is pending. Default modern translation: आपका Rs. 3000 का EMI pending है (when `null` is passed). With postprocessing enabled: - **roman output**: aapka Rs. 3000 ka EMI pending hai.
  - Allowed values: `roman`, `fully-native`, `spoken-form-in-native`
- `numerals_format` (enum, optional) — `numerals_format` is an optional parameter with two options (supported for both mayura:v1 and sarvam-translate:v1): - **`international`** (default): Uses regular numerals (0-9). - **`native`**: Uses language-specific native numerals. ### Example: - If `international` format is selected, we use regular numerals (0-9). For example: `मेरा phone number है: 9840950950`. - If `native` format is selected, we use language-specific native numerals, like: `मेरा phone number है: ९८४०९५०९५०`.
  - Allowed values: `international`, `native`

## Response

### 200

Successful Response

- `request_id` (string, required, nullable)
- `translated_text` (string, required) — Translated text result in the requested target language.
- `source_language_code` (string, required) — Detected or provided source language of the input text.

## Examples

**Request**

```json
{
  "input": "Hello, how are you?",
  "source_language_code": "en-IN",
  "target_language_code": "hi-IN"
}
```

**Response**

```json
{
  "request_id": "20250101_0a1b2c3d-1234-5678-9abc-def012345678",
  "translated_text": "नमस्ते, आप कैसे हैं?",
  "source_language_code": "en-IN"
}
```

**SDK Code**

```typescript
import { SarvamAIClient } from "sarvamai";

const client = new SarvamAIClient({
  apiSubscriptionKey: process.env.SARVAM_API_KEY,
});

const response = await client.text.translate({
  input: "Hello, how are you?",
  source_language_code: "en-IN",
  target_language_code: "hi-IN",
});

```

```typescript
import { SarvamAIClient } from "sarvamai";

async function main() {
    const client = new SarvamAIClient({
        apiSubscriptionKey: "YOUR_API_KEY_HERE",
    });
    await client.text.translate({
        input: "Hello, how are you?",
        source_language_code: "en-IN",
        target_language_code: "hi-IN",
    });
}
main();

```

```python
from sarvamai import SarvamAI

client = SarvamAI(
    api_subscription_key="YOUR_API_KEY_HERE",
)

client.text.translate(
    input="Hello, how are you?",
    source_language_code="en-IN",
    target_language_code="hi-IN",
)

```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sarvam.ai/translate"

	payload := strings.NewReader("{\n  \"input\": \"Hello, how are you?\",\n  \"source_language_code\": \"en-IN\",\n  \"target_language_code\": \"hi-IN\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("api-subscription-key", "<apiSubscriptionKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sarvam.ai/translate")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["api-subscription-key"] = '<apiSubscriptionKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"input\": \"Hello, how are you?\",\n  \"source_language_code\": \"en-IN\",\n  \"target_language_code\": \"hi-IN\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sarvam.ai/translate")
  .header("api-subscription-key", "<apiSubscriptionKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"input\": \"Hello, how are you?\",\n  \"source_language_code\": \"en-IN\",\n  \"target_language_code\": \"hi-IN\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sarvam.ai/translate', [
  'body' => '{
  "input": "Hello, how are you?",
  "source_language_code": "en-IN",
  "target_language_code": "hi-IN"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'api-subscription-key' => '<apiSubscriptionKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sarvam.ai/translate");
var request = new RestRequest(Method.POST);
request.AddHeader("api-subscription-key", "<apiSubscriptionKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"input\": \"Hello, how are you?\",\n  \"source_language_code\": \"en-IN\",\n  \"target_language_code\": \"hi-IN\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "api-subscription-key": "<apiSubscriptionKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "input": "Hello, how are you?",
  "source_language_code": "en-IN",
  "target_language_code": "hi-IN"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sarvam.ai/translate")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```